<?php
/*********************************************************************
    class.second_status.php

    Second Status

    Irfan Merali

    Released under the GNU General Public License WITHOUT ANY WARRANTY.
    See LICENSE.TXT for details.

    vim: expandtab sw=4 ts=4 sts=4:
**********************************************************************/
class WORK {

    var $sec_stat_id;

    var $info;

    function WORK($sec_stat_id) {
        $this->sec_stat_id=0;
        $this->load($sec_stat_id);
    }

    function load($sec_stat_id=0) {

        if(!$sec_stat_id && !($sec_stat_id=$this->getId()))
            return false;

        $sql='SELECT ht.* ' 
	    .' FROM '.SECOND_STATUS_TABLE.' ht '
	    .' WHERE ht.sec_stat_id='.db_input($sec_stat_id);

        if(!($res=db_query($sql)) || !db_num_rows($res))
            return false;

        $this->ht=db_fetch_array($res);
        $this->sec_stat_id=$this->ht['sec_stat_id'];
        return true;
    }

    function reload() {
        return $this->load();
    }

    function asVar() {
        return $this->getName();
    }

    function getId() {
        return $this->sec_stat_id;
    }

    function getName() {
        return $this->ht['sec_stat_name'];
    }

    function getHashtable() {
        return  $this->ht;
    }

    function getInfo() {
        return $this->getHashtable();
    }

    function isActive() {
        return ($this->ht['sec_stat_isactive']);
    }

    function update($vars,&$errors) {
        
        if(!WORK::save($this->getId(),$vars,$errors))
            return false;

        $this->reload();

        return true;
    }

    function delete() {
        global $cfg;

        if(!$cfg || $cfg->getDefaultWORKId()==$this->getId())
            return false;

        $sec_stat_id=$this->getId();
        $sql='DELETE FROM '.SECOND_STATUS_TABLE.' WHERE sec_stat_id='.db_input($sec_stat_id).' LIMIT 1';
        if(db_query($sql) && ($num=db_affected_rows())) {
            db_query('UPDATE '.TICKET_TABLE.' SET work='.db_input($cfg->getDefaultWORKId()).' WHERE work='.db_input($sec_stat_id));
        }

        return $num;
    }

    /** static functions **/
    function create($vars,&$errors) {
        return WORK::save(0,$vars,$errors);
    }

    function getWORKs() {

        $sec_stats=array();
        $sql='SELECT sec_stat_id, sec_stat_name, sec_stat_isactive FROM '.SECOND_STATUS_TABLE.' ORDER BY sec_stat_name';
        if(($res=db_query($sql)) && db_num_rows($res)) {
            while($row=db_fetch_array($res))
                $sec_stats[$row['sec_stat_id']] = sprintf('%s (%d hrs - %s)',
                        $row['sec_stat_name'], 
                        $row['sec_stat_isactive']?'Active':'Disabled');
        }

        return $sec_stats;
    }


    function getIdByName($sec_stat_name) {

        $sql='SELECT sec_stat_id FROM '.SECOND_STATUS_TABLE.' WHERE sec_stat_name='.db_input($sec_stat_name);
        if(($res=db_query($sql)) && db_num_rows($res))
            list($sec_stat_id)=db_fetch_row($res);

        return $sec_stat_id;
    }

    function lookup($sec_stat_id) {
        return ($sec_stat_id && is_numeric($sec_stat_id) && ($sec_stat= new WORK($sec_stat_id)) && $sec_stat->getId()==$sec_stat_id)?$sec_stat:null;
    }

    function save($sec_stat_id,$vars,&$errors) {

         
        if(!$vars['sec_stat_name'])
            $errors['sec_stat_name']='Name required';
        elseif(($sid=WORK::getIdByName($vars['sec_stat_name'])) && $sid!=$sec_stat_id)
            $errors['sec_stat_name']='Name already exists';

        if($errors) return false;

        $sql=' sec_stat_updated=NOW() '.
             ',sec_stat_isactive='.db_input($vars['sec_stat_isactive']).
             ',sec_stat_name='.db_input($vars['sec_stat_name']);

        if($sec_stat_id) {
            $sql='UPDATE '.SECOND_STATUS_TABLE.' SET '.$sql.' WHERE sec_stat_id='.db_input($sec_stat_id);
            if(db_query($sql))
                return true;

            $errors['err']='Unable to update Second Status. Internal error occurred';
        }else{
            $sql='INSERT INTO '.SECOND_STATUS_TABLE.' SET '.$sql.',sec_stat_created=NOW() ';
            if(db_query($sql) && ($sec_stat_id=db_insert_id()))
                return $sec_stat_id;

            $errors['err']='Unable to add Second Status. Internal error';
        }

        return false;
    }
}
?>
