<?php
/*********************************************************************
    second_status.php

    Second Status - Ticket Second Status.

    Irfan Merali

    Released under the GNU General Public License WITHOUT ANY WARRANTY.
    See LICENSE.TXT for details.

    vim: expandtab sw=4 ts=4 sts=4:
**********************************************************************/
require('admin.inc.php');
include_once(INCLUDE_DIR.'class.second_status.php');

$sec_stat=null;
if($_REQUEST['sec_stat_id'] && !($sec_stat=WORK::lookup($_REQUEST['sec_stat_id'])))
    $errors['err']='Unknown or invalid API key ID.';

if($_POST){
    switch(strtolower($_POST['do'])){
        case 'update':
            if(!$sec_stat){
                $errors['err']='Unknown or invalid Second Status.';
            }elseif($sec_stat->update($_POST,$errors)){
                $msg='Second Status updated successfully';
            }elseif(!$errors['err']){
                $errors['err']='Error updating Second Status. Try again!';
            }
            break;
        case 'add':
            if(($sec_stat_id=WORK::create($_POST,$errors))){
                $msg='Second Status added successfully';
                $_REQUEST['a']=null;
            }elseif(!$errors['err']){
                $errors['err']='Unable to add Second Status. Correct error(s) below and try again.';
            }
            break;
        case 'mass_process':
            if(!$_POST['ids'] || !is_array($_POST['ids']) || !count($_POST['ids'])) {
                $errors['err'] = 'You must select at least one Second Status.';
            } else {
                $count=count($_POST['ids']);
                switch(strtolower($_POST['a'])) {
                    case 'enable':
                        $sql='UPDATE '.SECOND_STATUS_TABLE.' SET sec_stat_isactive=1 '
                            .' WHERE sec_stat_id IN ('.implode(',', db_input($_POST['ids'])).')';
                    
                        if(db_query($sql) && ($num=db_affected_rows())) {
                            if($num==$count)
                                $msg = 'Selected Second Status enabled';
                            else
                                $warn = "$num of $count selected Second Status enabled";
                        } else {
                            $errors['err'] = 'Unable to enable selected Second Status.';
                        }
                        break;
                    case 'disable':
                        $sql='UPDATE '.SECOND_STATUS_TABLE.' SET sec_stat_isactive=0 '
                            .' WHERE sec_stat_id IN ('.implode(',', db_input($_POST['ids'])).')';
                        if(db_query($sql) && ($num=db_affected_rows())) {
                            if($num==$count)
                                $msg = 'Selected Second Status disabled';
                            else
                                $warn = "$num of $count selected Second Status disabled";
                        } else {
                            $errors['err'] = 'Unable to disable selected Second Status';
                        }
                        break;
                    case 'delete':
                        $i=0;
                        foreach($_POST['ids'] as $k=>$v) {
                            if(($p=WORK::lookup($v)) && $p->delete())
                                $i++;
                        }

                        if($i && $i==$count)
                            $msg = 'Selected Second Status deleted successfully';
                        elseif($i>0)
                            $warn = "$i of $count selected Second Status deleted";
                        elseif(!$errors['err'])
                            $errors['err'] = 'Unable to delete selected Second Status';
                        break;
                    default:
                        $errors['err']='Unknown action - get technical help.';
                }
            }
            break;
        default:
            $errors['err']='Unknown action/command';
            break;
    }
}

$page='second_status.inc.php';
if($sec_stat || ($_REQUEST['a'] && !strcasecmp($_REQUEST['a'],'add')))
    $page='sec_stat.inc.php';

$nav->setTabActive('manage');
require(STAFFINC_DIR.'header.inc.php');
require(STAFFINC_DIR.$page);
include(STAFFINC_DIR.'footer.inc.php');
?>
